/* this file is autogenerated, do not edit directly */
#include <windows.h>
#include <stdint.h>
#include "../fraktal_sft/floatexp.h"

static inline double d_add(const double a, const double b)
{
  return a + b;
}

static inline double d_sub(const double a, const double b)
{
  return a - b;
}

static inline double d_neg(const double a)
{
  return -a;
}

static inline double d_abs(const double a)
{
  return a < 0.0 ? -a : a;
}

static inline double d_imul(const int a, const double b)
{
  return a * b;
}

static inline double d_muli(const double a, const int b)
{
  return a * b;
}

static inline double d_mul(const double a, const double b)
{
  return a * b;
}

static inline double d_pow(const double a, const int b)
{
  double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int d_cmp(const double a, const double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline double d_diffabs(const double c, const double d)
{
  double cd = c + d;
  if (c >= 0.0)
  {
    if (cd >= 0.0)
    {
      return d;
    }
    else
    {
      return -d - 2.0 * c;
    }
  }
  else
  {
    if (cd > 0.0)
    {
      return d + 2.0 * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline long double ld_add(const long double a, const long double b)
{
  return a + b;
}

static inline long double ld_sub(const long double a, const long double b)
{
  return a - b;
}

static inline long double ld_neg(const long double a)
{
  return -a;
}

static inline long double ld_abs(const long double a)
{
  return a < 0.0 ? -a : a;
}

static inline long double ld_imul(const int a, const long double b)
{
  return a * b;
}

static inline long double ld_muli(const long double a, const int b)
{
  return a * b;
}

static inline long double ld_mul(const long double a, const long double b)
{
  return a * b;
}

static inline long double ld_pow(const long double a, const int b)
{
  long double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int ld_cmp(const long double a, const long double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline long double ld_diffabs(const long double c, const long double d)
{
  long double cd = c + d;
  if (c >= 0.0L)
  {
    if (cd >= 0.0L)
    {
      return d;
    }
    else
    {
      return - d - 2.0L * c;
    }
  }
  else
  {
    if (cd > 0.0L)
    {
      return d + 2.0L * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline int64_t as_long(double d)
{
  union {
    double d;
    int64_t i;
  } u;
  u.d = d;
  return u.i;
}

static inline double as_double(int64_t i)
{
  union {
    double d;
    int64_t i;
  } u;
  u.i = i;
  return u.d;
}

static inline double fe_double(floatexp f)
{
  if (f.exp < -1020)
  {
    return 0.0;
  }
  if (f.exp > 1020)
  {
    return f.val / 0.0;
  }
  return as_double((as_long(f.val) & 0x800FFFFFFFFFFFFFLL) | ((f.exp + 1023) << 52));
}

static inline floatexp fe_floatexp(const double val, const int64_t exp)
{
  int64_t f_exp = ((as_long(val) & 0x7FF0000000000000LL) >> 52) - 1023;
  double f_val = as_double((as_long(val) & 0x800FFFFFFFFFFFFFLL) | 0x3FF0000000000000LL);
  floatexp fe(f_val, f_exp + exp, 0);
  return fe;
}

static inline floatexp fe_abs(const floatexp f)
{
  floatexp fe(d_abs(f.val), f.exp, 0);
  return fe;
}

static inline floatexp fe_neg(const floatexp f)
{
  floatexp fe(-f.val, f.exp, 0);
  return fe;
}

static inline floatexp fe_muli(const floatexp a, const int b)
{
  return fe_floatexp(a.val * b, a.exp);
}

static inline floatexp fe_imul(const int a, const floatexp b)
{
  return fe_floatexp(a * b.val, b.exp);
}

static inline floatexp fe_mul(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val * b.val, a.exp + b.exp);
}

static inline floatexp fe_mul_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp + b, 0);
  return fe;
}

static inline floatexp fe_div(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val / b.val, a.exp - b.exp);
}

static inline floatexp fe_div_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp - b, 0);
  return fe;
}

static inline floatexp fe_add(const floatexp a, const floatexp b)
{
  if (a.exp > b.exp)
  {
    floatexp c(b.val, b.exp - a.exp, 0);
    return fe_floatexp(a.val + fe_double(c), a.exp);
  }
  else
  {
    floatexp c(a.val, a.exp - b.exp, 0);
    return fe_floatexp(fe_double(c) + b.val, b.exp);
  }
}

static inline floatexp fe_sub(const floatexp a, const floatexp b)
{
  return fe_add(a, fe_neg(b));
}

static inline int fe_cmp(const floatexp a, const floatexp b)
{
  if (a.val > 0)
  {
    if (b.val <= 0)
    {
      return 1;
    }
    else if (a.exp > b.exp)
    {
      return 1;
    }
    else if (a.exp < b.exp)
    {
      return -1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
  else
  {
    if (b.val > 0)
    {
      return -1;
    }
    else if (a.exp > b.exp)
    {
      return -1;
    }
    else if (a.exp < b.exp)
    {
      return 1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
}

static inline floatexp fe_diffabs(const floatexp c, const floatexp d)
{
  floatexp cd = fe_add(c, d);
  if (c.val >= 0.0)
  {
    if (cd.val >= 0.0)
    {
      return d;
    }
    else
    {
      return fe_neg(fe_add(d, fe_mul_2si(c, 1)));
    }
  }
  else
  {
    if (cd.val > 0.0)
    {
      return fe_add(d, fe_mul_2si(c, 1));
    }
    else
    {
      return fe_neg(d);
    }
  }
}

static inline floatexp fe_pow(const floatexp a, int b)
{
  floatexp r = fe_floatexp(1.0, 0);
  for (int i = 0; i < b; ++i)
  {
    r = fe_mul(r, a);
  }
  return r;
}

typedef struct
{
  double re;
  double im;
} dcomplex;

static inline dcomplex dc_neg(const dcomplex a)
{
  dcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline dcomplex dc_add(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline dcomplex dc_sub(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline dcomplex dc_imul(const int a, const dcomplex b)
{
  dcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline dcomplex dc_muli(const dcomplex a, const int b)
{
  dcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline dcomplex dc_mul(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline dcomplex dc_pow(const dcomplex a, const int b)
{
  dcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = dc_mul(r, a);
  }
  return r;
}

typedef struct
{
  long double re;
  long double im;
} ldcomplex;

static inline ldcomplex ldc_neg(const ldcomplex a)
{
  ldcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline ldcomplex ldc_add(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline ldcomplex ldc_sub(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline ldcomplex ldc_imul(const int a, const ldcomplex b)
{
  ldcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline ldcomplex ldc_muli(const ldcomplex a, const int b)
{
  ldcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline ldcomplex ldc_mul(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline ldcomplex ldc_pow(const ldcomplex a, const int b)
{
  ldcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = ldc_mul(r, a);
  }
  return r;
}

typedef struct
{
  floatexp re;
  floatexp im;
} fecomplex;

static inline fecomplex fec_neg(const fecomplex a)
{
  fecomplex fec = { fe_neg(a.re), fe_neg(a.im) };
  return fec;
}

static inline fecomplex fec_add(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_add(a.re, b.re), fe_add(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_sub(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(a.re, b.re), fe_sub(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_imul(const int a, const fecomplex b)
{
  fecomplex fec = { fe_imul(a, b.re), fe_imul(a, b.im) };
  return fec;
}

static inline fecomplex fec_muli(const fecomplex a, const int b)
{
  fecomplex fec = { fe_muli(a.re, b), fe_muli(a.im, b) };
  return fec;
}

static inline fecomplex fec_mul(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(fe_mul(a.re, b.re), fe_mul(a.im, b.im)), fe_add(fe_mul(a.re, b.im), fe_mul(a.im, b.re)) };
  return fec;
}

static inline fecomplex fec_pow(const fecomplex a, const int b)
{
  fecomplex r = { fe_floatexp(1.0, 0), fe_floatexp(0.0, 0) };
  for (int i = 0; i < b; ++i)
  {
    r = fec_mul(r, a);
  }
  return r;
}


#include "../fraktal_sft/CFixedFloat.h"
#include "../fraktal_sft/floatexp.h"
#include "../fraktal_sft/complex.h"

#define FORMULA2(function,type,power) function ## _ ## type ## _ ## power
#define FORMULA(a,b,c) FORMULA2(a,b,c)

using std::abs;

static inline long double ConvertFromFixedFloat(const CFixedFloat &f)
{
  using std::ldexp;
  signed long int e = 0;
  long double l = mpfr_get_ld_2exp(&e, f.m_f.backend().data(), MPFR_RNDN);
  l = ldexp(l, e);
  return l;
}





bool FORMULA(reference_double,0,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul(t0,t1,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul(t0,t1,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul(t0,t1,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi)),cr);
xin=d_add(d_imul(2,d_add(d_mul(d_add(Xr,xr),xi),d_mul(Xi,xr))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_sub(ld_mul(ld_add(ld_imul(2,Xr),xr),xr),ld_mul(ld_add(ld_imul(2,Xi),xi),xi)),cr);
xin=ld_add(ld_imul(2,ld_add(ld_mul(ld_add(Xr,xr),xi),ld_mul(Xi,xr))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi)),cr);
xin=fe_add(fe_imul(2,fe_add(fe_mul(fe_add(Xr,xr),xi),fe_mul(Xi,xr))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_sub(d_add(d_sub(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(3,Xr),Xr),xr),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_mul(d_imul(3,Xi),Xi),xr)),d_mul(d_mul(d_imul(3,Xr),xr),xr)),d_mul(d_mul(d_imul(3,Xr),xi),xi)),d_mul(d_mul(d_muli(d_imul(3,Xi),2),xr),xi)),d_mul(d_mul(xr,xr),xr)),d_mul(d_mul(d_imul(3,xr),xi),xi)),cr);
xin=d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_mul(d_mul(d_imul(3,Xr),Xr),xi),d_mul(d_mul(d_imul(6,Xr),Xi),xr)),d_mul(d_mul(d_imul(3,Xi),Xi),xi)),d_mul(d_mul(d_muli(d_imul(3,Xr),2),xr),xi)),d_mul(d_mul(d_imul(3,Xi),xr),xr)),d_mul(d_mul(d_imul(3,Xi),xi),xi)),d_mul(d_mul(d_imul(3,xr),xr),xi)),d_mul(d_mul(xi,xi),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_mul(ld_imul(3,Xr),Xr),xr),ld_mul(ld_mul(ld_imul(6,Xr),Xi),xi)),ld_mul(ld_mul(ld_imul(3,Xi),Xi),xr)),ld_mul(ld_mul(ld_imul(3,Xr),xr),xr)),ld_mul(ld_mul(ld_imul(3,Xr),xi),xi)),ld_mul(ld_mul(ld_muli(ld_imul(3,Xi),2),xr),xi)),ld_mul(ld_mul(xr,xr),xr)),ld_mul(ld_mul(ld_imul(3,xr),xi),xi)),cr);
xin=ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_mul(ld_mul(ld_imul(3,Xr),Xr),xi),ld_mul(ld_mul(ld_imul(6,Xr),Xi),xr)),ld_mul(ld_mul(ld_imul(3,Xi),Xi),xi)),ld_mul(ld_mul(ld_muli(ld_imul(3,Xr),2),xr),xi)),ld_mul(ld_mul(ld_imul(3,Xi),xr),xr)),ld_mul(ld_mul(ld_imul(3,Xi),xi),xi)),ld_mul(ld_mul(ld_imul(3,xr),xr),xi)),ld_mul(ld_mul(xi,xi),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(3,Xr),Xr),xr),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_mul(fe_imul(3,Xi),Xi),xr)),fe_mul(fe_mul(fe_imul(3,Xr),xr),xr)),fe_mul(fe_mul(fe_imul(3,Xr),xi),xi)),fe_mul(fe_mul(fe_muli(fe_imul(3,Xi),2),xr),xi)),fe_mul(fe_mul(xr,xr),xr)),fe_mul(fe_mul(fe_imul(3,xr),xi),xi)),cr);
xin=fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(3,Xr),Xr),xi),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xr)),fe_mul(fe_mul(fe_imul(3,Xi),Xi),xi)),fe_mul(fe_mul(fe_muli(fe_imul(3,Xr),2),xr),xi)),fe_mul(fe_mul(fe_imul(3,Xi),xr),xr)),fe_mul(fe_mul(fe_imul(3,Xi),xi),xi)),fe_mul(fe_mul(fe_imul(3,xr),xr),xi)),fe_mul(fe_mul(xi,xi),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(4,dc_pow(X,3)),x),dc_mul(dc_imul(6,dc_pow(X,2)),dc_pow(x,2))),dc_mul(dc_imul(4,X),dc_pow(x,3))),dc_pow(x,4)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(4,ldc_pow(X,3)),x),ldc_mul(ldc_imul(6,ldc_pow(X,2)),ldc_pow(x,2))),ldc_mul(ldc_imul(4,X),ldc_pow(x,3))),ldc_pow(x,4)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(4,fec_pow(X,3)),x),fec_mul(fec_imul(6,fec_pow(X,2)),fec_pow(x,2))),fec_mul(fec_imul(4,X),fec_pow(x,3))),fec_pow(x,4)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(5,dc_pow(X,4)),x),dc_mul(dc_imul(10,dc_pow(X,3)),dc_pow(x,2))),dc_mul(dc_imul(10,dc_pow(X,2)),dc_pow(x,3))),dc_mul(dc_imul(5,X),dc_pow(x,4))),dc_pow(x,5)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(5,ldc_pow(X,4)),x),ldc_mul(ldc_imul(10,ldc_pow(X,3)),ldc_pow(x,2))),ldc_mul(ldc_imul(10,ldc_pow(X,2)),ldc_pow(x,3))),ldc_mul(ldc_imul(5,X),ldc_pow(x,4))),ldc_pow(x,5)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(5,fec_pow(X,4)),x),fec_mul(fec_imul(10,fec_pow(X,3)),fec_pow(x,2))),fec_mul(fec_imul(10,fec_pow(X,2)),fec_pow(x,3))),fec_mul(fec_imul(5,X),fec_pow(x,4))),fec_pow(x,5)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,6)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,6)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,6)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,6)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(6,dc_pow(X,5)),x),dc_mul(dc_imul(15,dc_pow(X,4)),dc_pow(x,2))),dc_mul(dc_imul(20,dc_pow(X,3)),dc_pow(x,3))),dc_mul(dc_imul(15,dc_pow(X,2)),dc_pow(x,4))),dc_mul(dc_imul(6,X),dc_pow(x,5))),dc_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,6)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(6,ldc_pow(X,5)),x),ldc_mul(ldc_imul(15,ldc_pow(X,4)),ldc_pow(x,2))),ldc_mul(ldc_imul(20,ldc_pow(X,3)),ldc_pow(x,3))),ldc_mul(ldc_imul(15,ldc_pow(X,2)),ldc_pow(x,4))),ldc_mul(ldc_imul(6,X),ldc_pow(x,5))),ldc_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,6)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(6,fec_pow(X,5)),x),fec_mul(fec_imul(15,fec_pow(X,4)),fec_pow(x,2))),fec_mul(fec_imul(20,fec_pow(X,3)),fec_pow(x,3))),fec_mul(fec_imul(15,fec_pow(X,2)),fec_pow(x,4))),fec_mul(fec_imul(6,X),fec_pow(x,5))),fec_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,7)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,7)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,7)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,7)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(7,dc_pow(X,6)),x),dc_mul(dc_imul(21,dc_pow(X,5)),dc_pow(x,2))),dc_mul(dc_imul(35,dc_pow(X,4)),dc_pow(x,3))),dc_mul(dc_imul(35,dc_pow(X,3)),dc_pow(x,4))),dc_mul(dc_imul(21,dc_pow(X,2)),dc_pow(x,5))),dc_mul(dc_imul(7,X),dc_pow(x,6))),dc_pow(x,7)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,7)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(7,ldc_pow(X,6)),x),ldc_mul(ldc_imul(21,ldc_pow(X,5)),ldc_pow(x,2))),ldc_mul(ldc_imul(35,ldc_pow(X,4)),ldc_pow(x,3))),ldc_mul(ldc_imul(35,ldc_pow(X,3)),ldc_pow(x,4))),ldc_mul(ldc_imul(21,ldc_pow(X,2)),ldc_pow(x,5))),ldc_mul(ldc_imul(7,X),ldc_pow(x,6))),ldc_pow(x,7)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,7)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(7,fec_pow(X,6)),x),fec_mul(fec_imul(21,fec_pow(X,5)),fec_pow(x,2))),fec_mul(fec_imul(35,fec_pow(X,4)),fec_pow(x,3))),fec_mul(fec_imul(35,fec_pow(X,3)),fec_pow(x,4))),fec_mul(fec_imul(21,fec_pow(X,2)),fec_pow(x,5))),fec_mul(fec_imul(7,X),fec_pow(x,6))),fec_pow(x,7)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,8)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,8)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,8)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,8)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(8,dc_pow(X,7)),x),dc_mul(dc_imul(28,dc_pow(X,6)),dc_pow(x,2))),dc_mul(dc_imul(56,dc_pow(X,5)),dc_pow(x,3))),dc_mul(dc_imul(70,dc_pow(X,4)),dc_pow(x,4))),dc_mul(dc_imul(56,dc_pow(X,3)),dc_pow(x,5))),dc_mul(dc_imul(28,dc_pow(X,2)),dc_pow(x,6))),dc_mul(dc_imul(8,X),dc_pow(x,7))),dc_pow(x,8)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,8)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(8,ldc_pow(X,7)),x),ldc_mul(ldc_imul(28,ldc_pow(X,6)),ldc_pow(x,2))),ldc_mul(ldc_imul(56,ldc_pow(X,5)),ldc_pow(x,3))),ldc_mul(ldc_imul(70,ldc_pow(X,4)),ldc_pow(x,4))),ldc_mul(ldc_imul(56,ldc_pow(X,3)),ldc_pow(x,5))),ldc_mul(ldc_imul(28,ldc_pow(X,2)),ldc_pow(x,6))),ldc_mul(ldc_imul(8,X),ldc_pow(x,7))),ldc_pow(x,8)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,8)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(8,fec_pow(X,7)),x),fec_mul(fec_imul(28,fec_pow(X,6)),fec_pow(x,2))),fec_mul(fec_imul(56,fec_pow(X,5)),fec_pow(x,3))),fec_mul(fec_imul(70,fec_pow(X,4)),fec_pow(x,4))),fec_mul(fec_imul(56,fec_pow(X,3)),fec_pow(x,5))),fec_mul(fec_imul(28,fec_pow(X,2)),fec_pow(x,6))),fec_mul(fec_imul(8,X),fec_pow(x,7))),fec_pow(x,8)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,9)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,9)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,9)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,9)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(9,dc_pow(X,8)),x),dc_mul(dc_imul(36,dc_pow(X,7)),dc_pow(x,2))),dc_mul(dc_imul(84,dc_pow(X,6)),dc_pow(x,3))),dc_mul(dc_imul(126,dc_pow(X,5)),dc_pow(x,4))),dc_mul(dc_imul(126,dc_pow(X,4)),dc_pow(x,5))),dc_mul(dc_imul(84,dc_pow(X,3)),dc_pow(x,6))),dc_mul(dc_imul(36,dc_pow(X,2)),dc_pow(x,7))),dc_mul(dc_imul(9,X),dc_pow(x,8))),dc_pow(x,9)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,9)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(9,ldc_pow(X,8)),x),ldc_mul(ldc_imul(36,ldc_pow(X,7)),ldc_pow(x,2))),ldc_mul(ldc_imul(84,ldc_pow(X,6)),ldc_pow(x,3))),ldc_mul(ldc_imul(126,ldc_pow(X,5)),ldc_pow(x,4))),ldc_mul(ldc_imul(126,ldc_pow(X,4)),ldc_pow(x,5))),ldc_mul(ldc_imul(84,ldc_pow(X,3)),ldc_pow(x,6))),ldc_mul(ldc_imul(36,ldc_pow(X,2)),ldc_pow(x,7))),ldc_mul(ldc_imul(9,X),ldc_pow(x,8))),ldc_pow(x,9)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,9)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(9,fec_pow(X,8)),x),fec_mul(fec_imul(36,fec_pow(X,7)),fec_pow(x,2))),fec_mul(fec_imul(84,fec_pow(X,6)),fec_pow(x,3))),fec_mul(fec_imul(126,fec_pow(X,5)),fec_pow(x,4))),fec_mul(fec_imul(126,fec_pow(X,4)),fec_pow(x,5))),fec_mul(fec_imul(84,fec_pow(X,3)),fec_pow(x,6))),fec_mul(fec_imul(36,fec_pow(X,2)),fec_pow(x,7))),fec_mul(fec_imul(9,X),fec_pow(x,8))),fec_pow(x,9)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,0,10)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,0,10)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,0,10)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,0,10)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(10,dc_pow(X,9)),x),dc_mul(dc_imul(45,dc_pow(X,8)),dc_pow(x,2))),dc_mul(dc_imul(120,dc_pow(X,7)),dc_pow(x,3))),dc_mul(dc_imul(210,dc_pow(X,6)),dc_pow(x,4))),dc_mul(dc_imul(252,dc_pow(X,5)),dc_pow(x,5))),dc_mul(dc_imul(210,dc_pow(X,4)),dc_pow(x,6))),dc_mul(dc_imul(120,dc_pow(X,3)),dc_pow(x,7))),dc_mul(dc_imul(45,dc_pow(X,2)),dc_pow(x,8))),dc_mul(dc_imul(10,X),dc_pow(x,9))),dc_pow(x,10)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,0,10)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(ldc_imul(10,ldc_pow(X,9)),x),ldc_mul(ldc_imul(45,ldc_pow(X,8)),ldc_pow(x,2))),ldc_mul(ldc_imul(120,ldc_pow(X,7)),ldc_pow(x,3))),ldc_mul(ldc_imul(210,ldc_pow(X,6)),ldc_pow(x,4))),ldc_mul(ldc_imul(252,ldc_pow(X,5)),ldc_pow(x,5))),ldc_mul(ldc_imul(210,ldc_pow(X,4)),ldc_pow(x,6))),ldc_mul(ldc_imul(120,ldc_pow(X,3)),ldc_pow(x,7))),ldc_mul(ldc_imul(45,ldc_pow(X,2)),ldc_pow(x,8))),ldc_mul(ldc_imul(10,X),ldc_pow(x,9))),ldc_pow(x,10)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,0,10)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(10,fec_pow(X,9)),x),fec_mul(fec_imul(45,fec_pow(X,8)),fec_pow(x,2))),fec_mul(fec_imul(120,fec_pow(X,7)),fec_pow(x,3))),fec_mul(fec_imul(210,fec_pow(X,6)),fec_pow(x,4))),fec_mul(fec_imul(252,fec_pow(X,5)),fec_pow(x,5))),fec_mul(fec_imul(210,fec_pow(X,4)),fec_pow(x,6))),fec_mul(fec_imul(120,fec_pow(X,3)),fec_pow(x,7))),fec_mul(fec_imul(45,fec_pow(X,2)),fec_pow(x,8))),fec_mul(fec_imul(10,X),fec_pow(x,9))),fec_pow(x,10)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,1,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,1,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,1,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,1,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),cr);
xin=d_add(d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,1,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,xr),Xr),ld_mul(xr,xr)),ld_mul(ld_imul(2,Xi),xi)),ld_mul(xi,xi)),cr);
xin=ld_add(ld_imul(2,ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,1,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),cr);
xin=fe_add(fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,1,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,1,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,1,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,1,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_add(d_mul(d_sub(d_mul(Xr,Xr),d_mul(d_imul(3,Xi),Xi)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(d_imul(6,Xi),xi)),d_mul(d_imul(3,xi),xi)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_mul(d_sub(d_mul(d_imul(3,Xr),Xr),d_mul(Xi,Xi)),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_mul(d_imul(3,xr),xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),d_abs(d_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,1,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_add(ld_mul(ld_sub(ld_mul(Xr,Xr),ld_mul(ld_imul(3,Xi),Xi)),ld_diffabs(Xr,xr)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),ld_mul(xr,xr)),ld_mul(ld_imul(6,Xi),xi)),ld_mul(ld_imul(3,xi),xi)),ld_abs(ld_add(Xr,xr)))),cr);
xin=ld_add(ld_add(ld_mul(ld_sub(ld_mul(ld_imul(3,Xr),Xr),ld_mul(Xi,Xi)),ld_diffabs(Xi,xi)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(6,Xr),xr),ld_mul(ld_imul(3,xr),xr)),ld_mul(ld_imul(2,Xi),xi)),ld_mul(xi,xi)),ld_abs(ld_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,1,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_add(fe_mul(fe_sub(fe_mul(Xr,Xr),fe_mul(fe_imul(3,Xi),Xi)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(fe_imul(6,Xi),xi)),fe_mul(fe_imul(3,xi),xi)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_mul(fe_imul(3,Xr),Xr),fe_mul(Xi,Xi)),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_mul(fe_imul(3,xr),xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),fe_abs(fe_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,1,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,1,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,1,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,1,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(12,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),xi),xi)),cr);
xin=d_add(d_add(d_mul(d_imul(4,d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi))),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_imul(4,d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi)))),d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,xi),Xi)),d_mul(xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,1,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(4,Xr),Xr),Xr),xr),ld_mul(ld_mul(ld_mul(ld_imul(6,Xr),Xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xr),xr),xr),xr)),ld_mul(ld_mul(ld_mul(xr,xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xi),Xi),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(6,Xi),Xi),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xi),xi),xi),xi)),ld_mul(ld_mul(ld_mul(xi,xi),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(12,Xr),Xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(6,Xr),Xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(12,Xr),xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(6,xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(12,xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(6,xr),xr),xi),xi)),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(4,ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi))),ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi)))),ld_mul(ld_imul(4,ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr,Xi),ld_mul(Xr,xi)),ld_mul(xr,Xi)),ld_mul(xr,xi)))),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,xr),Xr),ld_mul(xr,xr)),ld_mul(ld_imul(2,xi),Xi)),ld_mul(xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,1,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),xi),xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi))),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_imul(4,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,xi),Xi)),fe_mul(xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,1,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,1,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,1,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,1,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(d_mul(d_mul(Xr,Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(5,Xi),Xi),Xi),Xi))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(30,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(5,xi),xi),xi),xi)))),cr);
xin=d_add(d_add(d_mul(d_diffabs(Xi,xi),d_add(d_sub(d_mul(d_mul(d_mul(d_imul(5,Xr),Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(Xi,Xi),Xi),Xi))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(30,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(5,xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,1,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(ld_mul(ld_mul(Xr,Xr),Xr),Xr),ld_mul(ld_mul(ld_mul(ld_imul(10,Xr),Xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(5,Xi),Xi),Xi),Xi))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(4,Xr),Xr),Xr),xr),ld_mul(ld_mul(ld_mul(ld_imul(6,Xr),Xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xr),xr),xr),xr)),ld_mul(ld_mul(ld_mul(xr,xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),Xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,Xr),Xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,xr),xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xi),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(30,Xi),Xi),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),xi),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(5,xi),xi),xi),xi)))),cr);
xin=ld_add(ld_add(ld_mul(ld_diffabs(Xi,xi),ld_add(ld_sub(ld_mul(ld_mul(ld_mul(ld_imul(5,Xr),Xr),Xr),Xr),ld_mul(ld_mul(ld_mul(ld_imul(10,Xr),Xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(Xi,Xi),Xi),Xi))),ld_mul(ld_abs(ld_add(Xi,xi)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),Xr),Xr),xr),ld_mul(ld_mul(ld_mul(ld_imul(30,Xr),Xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(5,xr),xr),xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),Xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,Xr),Xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,xr),xr),Xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xr),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(10,xr),xr),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xi),Xi),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(6,Xi),Xi),xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(4,Xi),xi),xi),xi)),ld_mul(ld_mul(ld_mul(xi,xi),xi),xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,1,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(Xr,Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,Xi),Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(30,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,xi),xi),xi),xi)))),cr);
xin=fe_add(fe_add(fe_mul(fe_diffabs(Xi,xi),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(5,Xr),Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(Xi,Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(30,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(5,xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,2,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,2,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,2,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,2,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))),cr);
xin=d_sub(ci,d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,2,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_diffabs(ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi)),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),ld_mul(xr,xr)),ld_mul(ld_imul(2,Xi),xi)),ld_mul(xi,xi))),cr);
xin=ld_sub(ci,ld_imul(2,ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,2,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))),cr);
xin=fe_sub(ci,fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,2,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,2,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,2,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,2,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_diffabs(d_mul(Xr,d_sub(d_mul(Xr,Xr),d_mul(d_imul(3,Xi),Xi))),d_sub(d_add(d_mul(xr,d_add(d_mul(d_imul(3,Xr),Xr),d_mul(xr,xr))),d_mul(d_imul(3,Xr),d_sub(d_sub(d_mul(xr,xr),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)))),d_mul(d_imul(3,xr),d_add(d_add(d_mul(Xi,Xi),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))))),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_mul(d_imul(3,Xr),Xr),d_mul(Xi,Xi))),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(xi,xi))),d_mul(d_imul(3,xi),d_add(d_add(d_mul(Xr,Xr),d_mul(d_imul(2,Xr),xr)),d_mul(xr,xr)))),d_mul(xi,d_add(d_mul(d_imul(3,Xi),Xi),d_mul(xi,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,2,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_diffabs(ld_mul(Xr,ld_sub(ld_mul(Xr,Xr),ld_mul(ld_imul(3,Xi),Xi))),ld_sub(ld_add(ld_mul(xr,ld_add(ld_mul(ld_imul(3,Xr),Xr),ld_mul(xr,xr))),ld_mul(ld_imul(3,Xr),ld_sub(ld_sub(ld_mul(xr,xr),ld_mul(ld_imul(2,Xi),xi)),ld_mul(xi,xi)))),ld_mul(ld_imul(3,xr),ld_add(ld_add(ld_mul(Xi,Xi),ld_mul(ld_imul(2,Xi),xi)),ld_mul(xi,xi))))),cr);
xin=ld_add(ld_diffabs(ld_mul(Xi,ld_sub(ld_mul(ld_imul(3,Xr),Xr),ld_mul(Xi,Xi))),ld_sub(ld_add(ld_mul(ld_imul(3,Xi),ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),ld_mul(xr,xr)),ld_mul(xi,xi))),ld_mul(ld_imul(3,xi),ld_add(ld_add(ld_mul(Xr,Xr),ld_mul(ld_imul(2,Xr),xr)),ld_mul(xr,xr)))),ld_mul(xi,ld_add(ld_mul(ld_imul(3,Xi),Xi),ld_mul(xi,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,2,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(fe_mul(Xr,Xr),fe_mul(fe_imul(3,Xi),Xi))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_mul(fe_imul(3,Xr),Xr),fe_mul(xr,xr))),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(fe_mul(xr,xr),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)))),fe_mul(fe_imul(3,xr),fe_add(fe_add(fe_mul(Xi,Xi),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))))),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_mul(fe_imul(3,Xr),Xr),fe_mul(Xi,Xi))),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(xi,xi))),fe_mul(fe_imul(3,xi),fe_add(fe_add(fe_mul(Xr,Xr),fe_mul(fe_imul(2,Xr),xr)),fe_mul(xr,xr)))),fe_mul(xi,fe_add(fe_mul(fe_imul(3,Xi),Xi),fe_mul(xi,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,2,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,2,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,2,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,2,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,2,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_diffabs(ld_sub(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),Xi),ld_mul(ld_mul(ld_imul(4,Xr),Xi2),Xi)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_mul(ld_imul(-4,xr),Xi2),Xi),ld_mul(ld_mul(ld_imul(12,xi),Xr),Xi2)),ld_mul(ld_mul(ld_imul(12,xr),xi),Xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr2),Xi)),ld_mul(ld_mul(ld_imul(12,xi2),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi),Xr2),Xr)),ld_mul(ld_mul(ld_imul(12,xr),xi),Xr2)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xr)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xr)),ld_mul(ld_mul(ld_imul(4,xr),xi2),xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,2,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,2,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,2,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,2,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,2,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,2,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(5,Xr),Xi2),Xi2),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),Xi2)),ld_mul(ld_mul(Xr2,Xr2),Xr)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi),Xi2),Xi),ld_mul(ld_mul(ld_imul(30,Xr2),xr),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr2),Xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr),xr2),xi),Xi)),ld_mul(ld_mul(ld_imul(5,Xr2),Xr2),xr)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xr2)),ld_mul(ld_mul(ld_imul(30,Xr2),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xr),xr2),xr2)),ld_mul(ld_mul(ld_imul(5,xr),Xi2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi),Xi2),Xi)),ld_mul(ld_mul(ld_imul(30,xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_imul(5,xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),xi2)),ld_mul(ld_mul(xr2,xr2),xr))),cr);
xin=ld_add(ld_diffabs(ld_add(ld_sub(ld_mul(ld_mul(Xi2,Xi2),Xi),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),Xr2)),ld_mul(ld_mul(ld_imul(5,Xi),Xr2),Xr2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xr),Xr)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),xr),xi),Xr)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),xr),Xr2),Xr)),ld_mul(ld_mul(ld_imul(30,Xi),xi2),Xr2)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),xr),xi2),Xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),xr2),xr),Xr)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),xr),Xr2),Xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_imul(30,xi),xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),xr),Xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),xr2),xr),Xr)),ld_mul(ld_mul(xi2,xi2),xi)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,2,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,3,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,3,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,3,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,3,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi))),cr);
xin=d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),d_add(Xi,xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,3,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_diffabs(ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi)),ld_sub(ld_mul(ld_add(ld_imul(2,Xr),xr),xr),ld_mul(ld_add(ld_imul(2,Xi),xi),xi))),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(2,Xr),xi),ld_mul(ld_imul(2,xr),ld_add(Xi,xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,3,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),fe_add(Xi,xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,3,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,3,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,3,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,3,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_mul(Xr,d_sub(Xr2,d_imul(3,Xi2))),d_sub(d_add(d_mul(xr,d_add(d_imul(3,Xr2),xr2)),d_mul(d_imul(3,Xr),d_sub(d_sub(xr2,d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)))),cr);
xin=d_add(d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(xi2,d_imul(3,Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,3,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_mul(Xr,ld_sub(Xr2,ld_imul(3,Xi2))),ld_sub(ld_add(ld_mul(xr,ld_add(ld_imul(3,Xr2),xr2)),ld_mul(ld_imul(3,Xr),ld_sub(ld_sub(xr2,ld_mul(ld_imul(2,Xi),xi)),xi2))),ld_mul(ld_imul(3,xr),ld_add(ld_add(Xi2,ld_mul(ld_imul(2,Xi),xi)),xi2)))),cr);
xin=ld_add(ld_sub(ld_add(ld_mul(ld_imul(3,Xi),ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2)),ld_mul(ld_imul(3,xi),ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2))),ld_mul(xi,ld_add(xi2,ld_imul(3,Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,3,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(Xr2,fe_imul(3,Xi2))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2)),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(xr2,fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)))),cr);
xin=fe_add(fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(xi2,fe_imul(3,Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,3,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,3,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,3,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,3,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,3,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xr),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xr2)),ld_mul(ld_mul(ld_imul(12,Xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xi)),ld_mul(ld_mul(ld_imul(12,Xr2),xi),xr)),ld_mul(ld_mul(ld_imul(12,Xr),xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xi2),xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xi)),ld_mul(ld_mul(ld_imul(4,xr),Xi2),Xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,xr2),xr),xi)),ld_mul(ld_mul(ld_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,3,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,3,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,3,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,3,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,3,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xr2,Xr2),Xr),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,3,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_add(ld_sub(ld_mul(ld_mul(Xr2,Xr2),Xr),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),Xi2)),ld_mul(ld_mul(ld_imul(5,Xr),Xi2),Xi2)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi),Xi2),Xi),ld_mul(ld_mul(ld_imul(30,Xr2),xr),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr2),Xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr),xr2),xi),Xi)),ld_mul(ld_mul(ld_imul(5,Xr2),Xr2),xr)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xr2)),ld_mul(ld_mul(ld_imul(30,Xr2),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xr),xr2),xr2)),ld_mul(ld_mul(ld_imul(5,xr),Xi2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi),Xi2),Xi)),ld_mul(ld_mul(ld_imul(30,xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_imul(5,xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),xi2)),ld_mul(ld_mul(xr2,xr2),xr))),cr);
xin=ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr2),Xr),xr),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),Xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),Xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),Xr),xr),xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),Xr),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xr),xr)),ld_mul(ld_mul(ld_imul(30,xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),Xr),xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,3,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xr2,Xr2),Xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,4,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,4,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,4,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,4,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_sub(ci,d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,4,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2),ld_mul(ld_imul(2,xi),Xi)),cr);
xin=ld_sub(ci,ld_imul(2,ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,4,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_sub(ci,fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,4,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,4,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,4,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,4,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_sub(cr,d_mul(xr,d_add(d_imul(3,Xr2),xr2))),d_mul(d_imul(3,Xr),d_sub(d_add(xi2,d_mul(d_imul(2,Xi),xi)),xr2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)));
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(6,Xr),Xi),xr),d_mul(d_imul(3,Xi),xr2)),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(d_imul(3,Xr2),xi)),d_mul(d_mul(d_imul(6,Xr),xr),xi)),d_mul(d_imul(3,xr2),xi)),d_mul(xi2,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,4,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_sub(cr,ld_mul(xr,ld_add(ld_imul(3,Xr2),xr2))),ld_mul(ld_imul(3,Xr),ld_sub(ld_add(xi2,ld_mul(ld_imul(2,Xi),xi)),xr2))),ld_mul(ld_imul(3,xr),ld_add(ld_add(Xi2,ld_mul(ld_imul(2,Xi),xi)),xi2)));
xin=ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_mul(ld_imul(6,Xr),Xi),xr),ld_mul(ld_imul(3,Xi),xr2)),ld_mul(ld_imul(3,Xi2),xi)),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(ld_imul(3,Xr2),xi)),ld_mul(ld_mul(ld_imul(6,Xr),xr),xi)),ld_mul(ld_imul(3,xr2),xi)),ld_mul(xi2,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,4,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(cr,fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2))),fe_mul(fe_imul(3,Xr),fe_sub(fe_add(xi2,fe_mul(fe_imul(2,Xi),xi)),xr2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)));
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(6,Xr),Xi),xr),fe_mul(fe_imul(3,Xi),xr2)),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(fe_imul(3,Xr2),xi)),fe_mul(fe_mul(fe_imul(6,Xr),xr),xi)),fe_mul(fe_imul(3,xr2),xi)),fe_mul(xi2,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,4,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,4,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,4,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,4,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_mul(d_mul(d_imul(-12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,4,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(-12,Xr2),Xi),xr),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xr2)),ld_mul(ld_mul(ld_imul(12,Xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xi)),ld_mul(ld_mul(ld_imul(12,Xr2),xi),xr)),ld_mul(ld_mul(ld_imul(12,Xr),xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xi2),xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xi)),ld_mul(ld_mul(ld_imul(4,xr),Xi2),Xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,xr2),xr),xi)),ld_mul(ld_mul(ld_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,4,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(-12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,4,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,4,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,4,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,4,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(5,Xr2),Xr2),xr),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),Xi),xi)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(xr2,xr2),xr)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),cr);
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_mul(d_mul(d_imul(-20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,4,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(5,Xr2),Xr2),xr),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xr2)),ld_mul(ld_mul(ld_imul(10,Xr2),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xr),xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr2),Xr),Xi),xi)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xi2)),ld_mul(ld_mul(ld_imul(30,Xr2),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr2),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(30,Xr2),xr),xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr),xr2),Xi),xi)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),Xi2),Xi),xi)),ld_mul(ld_mul(ld_imul(30,Xr),Xi2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),Xi),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xr),xi2),xi2)),ld_mul(ld_mul(xr2,xr2),xr)),ld_mul(ld_mul(ld_imul(10,xr2),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr2),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(10,xr2),xr),xi2)),ld_mul(ld_mul(ld_imul(5,xr),Xi2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),Xi2),Xi),xi)),ld_mul(ld_mul(ld_imul(30,xr),Xi2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),Xi),xi2),xi)),ld_mul(ld_mul(ld_imul(5,xr),xi2),xi2)),cr);
xin=ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_mul(ld_mul(ld_imul(-20,Xi),Xr2),Xr),xr),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),Xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),Xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),Xr),xr),xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),Xr),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xr),xr)),ld_mul(ld_mul(ld_imul(30,xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),Xr),xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,4,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(xr2,xr2),xr)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),cr);
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(-20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,5,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,5,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,5,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,5,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_muli(d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)),-2),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,5,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi)),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2)),cr);
xin=ld_add(ld_muli(ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi)),-2),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,5,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_muli(fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)),-2),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,6,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,6,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,6,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,6,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,6,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2),ld_mul(ld_imul(2,xi),Xi)),cr);
xin=ld_add(ld_add(ld_muli(ld_mul(ld_abs(ld_add(Xr,xr)),xi),-2),ld_muli(ld_mul(ld_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,6,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,7,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,7,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,7,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,7,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,7,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2),ld_mul(ld_imul(2,xi),Xi)),cr);
xin=ld_add(ld_add(ld_muli(ld_mul(ld_diffabs(Xi,xi),Xr),-2),ld_muli(ld_mul(xr,ld_abs(ld_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,7,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,8,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,8,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,8,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,8,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,8,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi)),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2)),cr);
xin=ld_add(ld_add(ld_muli(ld_mul(ld_abs(ld_add(Xr,xr)),xi),-2),ld_muli(ld_mul(ld_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,8,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,9,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,9,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,9,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,9,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,9,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_mul(Xr,Xr),ld_mul(Xi,Xi)),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2)),cr);
xin=ld_add(ld_add(ld_muli(ld_mul(ld_diffabs(Xi,xi),Xr),-2),ld_muli(ld_mul(xr,ld_abs(ld_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,9,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,10,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,10,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,10,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,10,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(ci,d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,10,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_sub(Xr2,ld_imul(3,Xi2)),ld_diffabs(Xr,xr)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,xr),Xr),xr2),ld_mul(ld_imul(6,Xi),xi)),ld_imul(3,xi2)),ld_abs(ld_add(Xr,xr)))),cr);
xin=ld_sub(ci,ld_diffabs(ld_mul(Xi,ld_sub(ld_imul(3,Xr2),Xi2)),ld_sub(ld_add(ld_mul(ld_imul(3,Xi),ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2)),ld_mul(ld_imul(3,xi),ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2))),ld_mul(xi,ld_add(ld_imul(3,Xi2),xi2)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,10,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,11,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,11,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,11,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,11,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_imul(6,Xr),d_add(d_mul(Xi,xr),d_mul(xr,xi))),d_mul(d_imul(3,Xi),d_sub(xr2,xi2))),d_mul(d_imul(3,xi),d_sub(Xr2,Xi2))),d_mul(xi,d_sub(d_imul(3,xr2),xi2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,11,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_sub(Xr2,ld_imul(3,Xi2)),ld_diffabs(Xr,xr)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,xr),Xr),xr2),ld_mul(ld_imul(6,Xi),xi)),ld_imul(3,xi2)),ld_abs(ld_add(Xr,xr)))),cr);
xin=ld_add(ld_add(ld_add(ld_add(ld_mul(ld_imul(6,Xr),ld_add(ld_mul(Xi,xr),ld_mul(xr,xi))),ld_mul(ld_imul(3,Xi),ld_sub(xr2,xi2))),ld_mul(ld_imul(3,xi),ld_sub(Xr2,Xi2))),ld_mul(xi,ld_sub(ld_imul(3,xr2),xi2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,11,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(6,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xr,xi))),fe_mul(fe_imul(3,Xi),fe_sub(xr2,xi2))),fe_mul(fe_imul(3,xi),fe_sub(Xr2,Xi2))),fe_mul(xi,fe_sub(fe_imul(3,xr2),xi2))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,12,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,12,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,12,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,12,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_add(d_mul(d_sub(d_imul(3,Xr2),Xi2),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,xr),Xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,12,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(ld_mul(ld_imul(6,Xr),Xi),xi)),ld_mul(ld_imul(3,Xr),xi2)),ld_mul(xr,xr2)),ld_mul(ld_imul(3,Xi2),xr)),ld_mul(ld_mul(ld_imul(6,Xi),xr),xi)),ld_mul(ld_imul(3,xr),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_sub(ld_imul(3,Xr2),Xi2),ld_diffabs(Xi,xi)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(6,xr),Xr),ld_imul(3,xr2)),ld_mul(ld_imul(2,Xi),xi)),xi2),ld_abs(ld_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,12,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_imul(3,Xr2),Xi2),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,xr),Xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(Xi,xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,13,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,13,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,13,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,13,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,13,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(ld_mul(ld_imul(6,Xr),Xi),xi)),ld_mul(ld_imul(3,Xr),xi2)),ld_mul(xr,xr2)),ld_mul(ld_imul(3,Xi2),xr)),ld_mul(ld_mul(ld_imul(6,Xi),xr),xi)),ld_mul(ld_imul(3,xr),xi2)),cr);
xin=ld_add(ld_diffabs(ld_mul(Xi,ld_sub(ld_imul(3,Xr2),Xi2)),ld_sub(ld_add(ld_mul(ld_imul(3,Xi),ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),xi2)),ld_mul(ld_imul(3,xi),ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2))),ld_mul(xi,ld_add(ld_imul(3,Xi2),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,13,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,14,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,14,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,14,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,14,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(d_sub(ci,d_mul(d_diffabs(d_sub(d_imul(3,Xr2),Xi2),d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2)),Xi)),d_mul(d_abs(d_sub(d_sub(d_sub(d_add(d_add(d_imul(3,Xr2),d_mul(d_imul(6,Xr),xr)),d_imul(3,xr2)),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)),xi));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,14,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_sub(Xr2,ld_imul(3,Xi2)),ld_diffabs(Xr,xr)),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,xr),Xr),xr2),ld_mul(ld_imul(6,Xi),xi)),ld_imul(3,xi2)),ld_abs(ld_add(Xr,xr)))),cr);
xin=ld_sub(ld_sub(ci,ld_mul(ld_diffabs(ld_sub(ld_imul(3,Xr2),Xi2),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(6,Xr),xr),ld_imul(3,xr2)),ld_mul(ld_imul(2,Xi),xi)),xi2)),Xi)),ld_mul(ld_abs(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_imul(3,Xr2),ld_mul(ld_imul(6,Xr),xr)),ld_imul(3,xr2)),Xi2),ld_mul(ld_imul(2,Xi),xi)),xi2)),xi));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,14,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(fe_sub(ci,fe_mul(fe_diffabs(fe_sub(fe_imul(3,Xr2),Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2)),Xi)),fe_mul(fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_imul(3,Xr2),fe_mul(fe_imul(6,Xr),xr)),fe_imul(3,xr2)),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)),xi));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,15,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,15,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,15,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,15,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,15,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xi,xi)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_mul(ld_imul(12,Xr2),xr),ld_mul(ld_imul(12,Xr),xr2)),ld_mul(ld_imul(4,xr2),xr)),ld_mul(ld_imul(4,xr),Xi2)),ld_mul(ld_mul(ld_imul(8,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(8,xr),xi),Xi)),ld_mul(ld_imul(4,xi2),Xr)),ld_mul(ld_imul(4,xr),xi2))),ld_mul(ld_diffabs(Xi,xi),ld_sub(ld_mul(ld_imul(4,Xr2),Xr),ld_mul(ld_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,15,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,16,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,16,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,16,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,16,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,16,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xr,xr)),ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_imul(4,Xr2),xi),ld_mul(ld_mul(ld_imul(8,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(8,Xr),xr),xi)),ld_mul(ld_imul(4,xr2),Xi)),ld_mul(ld_imul(4,xr2),xi)),ld_mul(ld_imul(12,xi),Xi2)),ld_mul(ld_imul(12,xi2),Xi)),ld_mul(ld_imul(4,xi2),xi))),ld_mul(ld_diffabs(Xr,xr),ld_sub(ld_mul(ld_imul(4,Xr2),Xi),ld_mul(ld_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,16,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,17,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,17,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,17,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,17,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,17,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xr,xr)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_mul(ld_imul(12,Xi2),xi),ld_mul(ld_imul(12,Xi),xi2)),ld_mul(ld_imul(4,xi2),xi)),ld_mul(ld_mul(ld_imul(8,xr),Xr),Xi)),ld_mul(ld_imul(4,xr2),Xi)),ld_mul(ld_imul(4,xi),Xr2)),ld_mul(ld_mul(ld_imul(8,xr),xi),Xr)),ld_mul(ld_imul(4,xr2),xi))),ld_mul(ld_diffabs(Xr,xr),ld_sub(ld_mul(ld_imul(4,Xi2),Xi),ld_mul(ld_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,17,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,18,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,18,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,18,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,18,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,18,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xi,xi)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_mul(ld_imul(12,Xr2),xr),ld_mul(ld_imul(12,Xr),xr2)),ld_mul(ld_imul(4,xr2),xr)),ld_mul(ld_imul(4,xr),Xi2)),ld_mul(ld_mul(ld_imul(8,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(8,xr),xi),Xi)),ld_mul(ld_imul(4,xi2),Xr)),ld_mul(ld_imul(4,xr),xi2))),ld_mul(ld_diffabs(Xi,xi),ld_sub(ld_mul(ld_imul(4,Xr2),Xr),ld_mul(ld_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,18,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,19,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,19,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,19,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,19,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,19,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xr,xr)),ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_imul(4,Xr2),xi),ld_mul(ld_mul(ld_imul(8,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(8,Xr),xr),xi)),ld_mul(ld_imul(4,xr2),Xi)),ld_mul(ld_imul(4,xr2),xi)),ld_mul(ld_imul(12,xi),Xi2)),ld_mul(ld_imul(12,xi2),Xi)),ld_mul(ld_imul(4,xi2),xi))),ld_mul(ld_diffabs(Xr,xr),ld_sub(ld_mul(ld_imul(4,Xr2),Xi),ld_mul(ld_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,19,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,20,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,20,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,20,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,20,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,20,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_add(ld_mul(ld_abs(ld_add(Xr,xr)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_mul(ld_imul(12,Xi2),xi),ld_mul(ld_imul(12,Xi),xi2)),ld_mul(ld_imul(4,xi2),xi)),ld_mul(ld_mul(ld_imul(8,xr),Xr),Xi)),ld_mul(ld_imul(4,xr2),Xi)),ld_mul(ld_imul(4,xi),Xr2)),ld_mul(ld_mul(ld_imul(8,xr),xi),Xr)),ld_mul(ld_imul(4,xr2),xi))),ld_mul(ld_diffabs(Xr,xr),ld_sub(ld_mul(ld_imul(4,Xi2),Xi),ld_mul(ld_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,20,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,21,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,21,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,21,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,21,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,21,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_diffabs(ld_sub(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),Xi),ld_mul(ld_mul(ld_imul(4,Xr),Xi2),Xi)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_mul(ld_imul(-4,xr),Xi2),Xi),ld_mul(ld_mul(ld_imul(12,xi),Xr),Xi2)),ld_mul(ld_mul(ld_imul(12,xr),xi),Xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr2),Xi)),ld_mul(ld_mul(ld_imul(12,xi2),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi),Xr2),Xr)),ld_mul(ld_mul(ld_imul(12,xr),xi),Xr2)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xr)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xr)),ld_mul(ld_mul(ld_imul(4,xr),xi2),xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,21,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,22,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,22,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,22,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,22,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_sub(ci,d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,22,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_sub(ci,ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xr),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xr2)),ld_mul(ld_mul(ld_imul(12,Xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,Xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xi)),ld_mul(ld_mul(ld_imul(12,Xr2),xi),xr)),ld_mul(ld_mul(ld_imul(12,Xr),xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xi2),xi)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xi)),ld_mul(ld_mul(ld_imul(4,xr),Xi2),Xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi2),xi)),ld_mul(ld_mul(ld_imul(12,xr),Xi),xi2)),ld_mul(ld_mul(ld_imul(4,xr2),xr),xi)),ld_mul(ld_mul(ld_imul(4,xr),xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,22,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_sub(ci,fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,23,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,23,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,23,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,23,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,23,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_sub(ld_mul(ld_neg(ld_mul(ld_imul(4,Xr),Xi)),ld_diffabs(ld_sub(Xr2,Xi2),ld_add(ld_sub(ld_add(ld_mul(ld_imul(-2,xi),Xi),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(4,Xr),xi),ld_mul(ld_imul(4,xr),Xi)),ld_mul(ld_imul(4,xr),xi)),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_neg(Xi2),ld_mul(ld_imul(2,xi),Xi)),Xr2),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,23,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,24,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,24,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,24,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,24,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,24,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr),Xi),ld_diffabs(ld_sub(Xr2,Xi2),ld_add(ld_sub(ld_add(ld_mul(ld_imul(-2,xi),Xi),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(4,Xr),xi),ld_mul(ld_imul(4,xr),Xi)),ld_mul(ld_imul(4,xr),xi)),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_neg(Xi2),ld_mul(ld_imul(2,xi),Xi)),Xr2),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,24,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,25,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,25,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,25,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,25,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,25,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_sub(ld_mul(ld_neg(ld_mul(ld_imul(4,Xr),Xi)),ld_diffabs(ld_sub(Xr2,Xi2),ld_add(ld_sub(ld_add(ld_mul(ld_imul(-2,xi),Xi),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(4,Xr),xi),ld_mul(ld_imul(4,xr),Xi)),ld_mul(ld_imul(4,xr),xi)),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_neg(Xi2),ld_mul(ld_imul(2,xi),Xi)),Xr2),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,25,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,26,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,26,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,26,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,26,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,26,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,xr),Xr),Xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(12,xr2),xi),Xi)),ld_mul(ld_imul(6,xi2),Xr2)),ld_mul(ld_mul(ld_imul(12,xr),xi2),Xr)),ld_mul(ld_imul(6,xr2),xi2))),cr);
xin=ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr),Xi),ld_diffabs(ld_sub(Xr2,Xi2),ld_add(ld_sub(ld_add(ld_mul(ld_imul(-2,xi),Xi),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(4,Xr),xi),ld_mul(ld_imul(4,xr),Xi)),ld_mul(ld_imul(4,xr),xi)),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_neg(Xi2),ld_mul(ld_imul(2,xi),Xi)),Xr2),ld_mul(ld_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,26,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,27,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,27,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,27,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,27,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,27,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(Xr2,Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_imul(5,Xi2),Xi2))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(20,Xr2),Xi),xi)),ld_mul(ld_imul(10,Xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(20,Xr),xr),xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr2),Xi),xi)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xi)),ld_mul(ld_imul(30,Xi2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi),xi2),xi)),ld_mul(ld_imul(5,xi2),xi2)))),cr);
xin=ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr2),Xr),xr),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),Xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),Xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),Xr),xr),xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),Xr),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xr),xr)),ld_mul(ld_mul(ld_imul(30,xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),Xr),xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,27,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,28,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,28,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,28,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,28,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,28,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(Xr2,Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_imul(5,Xi2),Xi2))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(20,Xr2),Xi),xi)),ld_mul(ld_imul(10,Xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(20,Xr),xr),xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr2),Xi),xi)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xi)),ld_mul(ld_imul(30,Xi2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi),xi2),xi)),ld_mul(ld_imul(5,xi2),xi2)))),cr);
xin=ld_sub(ci,ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr2),Xr),xr),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),Xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),Xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),Xr),xr),xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),Xr),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xr),xr)),ld_mul(ld_mul(ld_imul(30,xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),Xr),xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,28,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,29,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,29,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,29,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,29,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,29,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(5,Xr),Xi2),Xi2),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),Xi2)),ld_mul(ld_mul(Xr2,Xr2),Xr)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi),Xi2),Xi),ld_mul(ld_mul(ld_imul(30,Xr2),xr),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr2),Xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xr),xr2),xi),Xi)),ld_mul(ld_mul(ld_imul(5,Xr2),Xr2),xr)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),Xr),xr2)),ld_mul(ld_mul(ld_imul(30,Xr2),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xr2),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(30,Xr),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xr),xr2),xr2)),ld_mul(ld_mul(ld_imul(5,xr),Xi2),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi),Xi2),Xi)),ld_mul(ld_mul(ld_imul(30,xr),xi2),Xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr),xi2),xi),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,xr2),xr),xi),Xi)),ld_mul(ld_mul(ld_imul(5,xr),xi2),xi2)),ld_mul(ld_mul(ld_imul(10,xr2),xr),xi2)),ld_mul(ld_mul(xr2,xr2),xr))),cr);
xin=ld_sub(ci,ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr2),Xr),xr),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),Xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),Xr2),xi2)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),Xr),xr)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),Xr),xr),xi)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),Xr),xr),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xr),xr)),ld_mul(ld_mul(ld_imul(30,xi),Xr2),xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),Xr),xr2),xr)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),Xr),xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,29,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,30,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,30,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,30,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,30,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,30,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(Xr2,Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_imul(5,Xi2),Xi2))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(20,Xr2),Xi),xi)),ld_mul(ld_imul(10,Xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(20,Xr),xr),xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr2),Xi),xi)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xi)),ld_mul(ld_imul(30,Xi2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi),xi2),xi)),ld_mul(ld_imul(5,xi2),xi2)))),cr);
xin=ld_sub(ci,ld_diffabs(ld_add(ld_sub(ld_mul(ld_mul(Xi2,Xi2),Xi),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),Xr2)),ld_mul(ld_mul(ld_imul(5,Xi),Xr2),Xr2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(5,Xi2),Xi2),xi),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xr),Xr)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xi2)),ld_mul(ld_mul(ld_imul(10,Xi2),Xi),xr2)),ld_mul(ld_mul(ld_imul(30,Xi2),xi),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi2),xr),xi),Xr)),ld_mul(ld_mul(ld_imul(10,Xi2),xi2),xi)),ld_mul(ld_mul(ld_imul(30,Xi2),xr2),xi)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),xr),Xr2),Xr)),ld_mul(ld_mul(ld_imul(30,Xi),xi2),Xr2)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(60,Xi),xr),xi2),Xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,Xi),xr2),xr),Xr)),ld_mul(ld_mul(ld_imul(5,Xi),xi2),xi2)),ld_mul(ld_mul(ld_imul(30,Xi),xr2),xi2)),ld_mul(ld_mul(ld_imul(5,Xi),xr2),xr2)),ld_mul(ld_mul(ld_imul(5,xi),Xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),xr),Xr2),Xr)),ld_mul(ld_mul(ld_imul(10,xi2),xi),Xr2)),ld_mul(ld_mul(ld_imul(30,xi),xr2),Xr2)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi2),xi),xr),Xr)),ld_mul(ld_mul(ld_mul(ld_imul(20,xi),xr2),xr),Xr)),ld_mul(ld_mul(xi2,xi2),xi)),ld_mul(ld_mul(ld_imul(10,xi2),xi),xr2)),ld_mul(ld_mul(ld_imul(5,xi),xr2),xr2))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,30,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))));
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,31,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,31,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,31,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,31,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_sub(d_mul(d_neg(Xi),d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,31,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(Xr2,Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_imul(5,Xi2),Xi2))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(20,Xr2),Xi),xi)),ld_mul(ld_imul(10,Xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(20,Xr),xr),xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr2),Xi),xi)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xi)),ld_mul(ld_imul(30,Xi2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi),xi2),xi)),ld_mul(ld_imul(5,xi2),xi2)))),cr);
xin=ld_add(ld_sub(ld_mul(ld_neg(Xi),ld_diffabs(ld_add(ld_sub(ld_mul(ld_imul(5,Xr2),Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(Xi2,Xi2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(4,xi),Xi2),Xi),ld_mul(ld_mul(ld_imul(20,xr),Xr),Xi2)),ld_mul(ld_imul(6,xi2),Xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr),Xr2),Xr)),ld_mul(ld_imul(10,xi2),Xr2)),ld_mul(ld_imul(30,xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),xi2),Xr)),ld_mul(ld_mul(ld_imul(20,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_imul(5,xr2),xr2)))),ld_mul(xi,ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_sub(ld_add(ld_mul(Xi2,Xi2),ld_mul(ld_mul(ld_imul(4,xi),Xi2),Xi)),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr),Xr),Xi2)),ld_mul(ld_imul(6,xi2),Xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr2),xi),Xi)),ld_mul(ld_imul(5,Xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),Xr2),Xr)),ld_mul(ld_imul(10,xi2),Xr2)),ld_mul(ld_imul(30,xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),xi2),Xr)),ld_mul(ld_mul(ld_imul(20,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,31,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(Xi),fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,32,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,32,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,32,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,32,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_mul(Xi,d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,32,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_mul(ld_diffabs(Xr,xr),ld_add(ld_sub(ld_mul(Xr2,Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_imul(5,Xi2),Xi2))),ld_mul(ld_abs(ld_add(Xr,xr)),ld_add(ld_add(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(20,Xr2),Xi),xi)),ld_mul(ld_imul(10,Xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(40,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(20,Xr),xr),xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr2),Xi),xi)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi2),Xi),xi)),ld_mul(ld_imul(30,Xi2),xi2)),ld_mul(ld_mul(ld_imul(20,Xi),xi2),xi)),ld_mul(ld_imul(5,xi2),xi2)))),cr);
xin=ld_add(ld_add(ld_mul(Xi,ld_diffabs(ld_add(ld_sub(ld_mul(ld_imul(5,Xr2),Xr2),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(Xi2,Xi2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(4,xi),Xi2),Xi),ld_mul(ld_mul(ld_imul(20,xr),Xr),Xi2)),ld_mul(ld_imul(6,xi2),Xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr),Xr2),Xr)),ld_mul(ld_imul(10,xi2),Xr2)),ld_mul(ld_imul(30,xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),xi2),Xr)),ld_mul(ld_mul(ld_imul(20,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_imul(5,xr2),xr2)))),ld_mul(xi,ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_sub(ld_add(ld_mul(Xi2,Xi2),ld_mul(ld_mul(ld_imul(4,xi),Xi2),Xi)),ld_mul(ld_imul(10,Xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xr),Xr),Xi2)),ld_mul(ld_imul(6,xi2),Xi2)),ld_mul(ld_imul(10,xr2),Xi2)),ld_mul(ld_mul(ld_imul(20,xi),Xr2),Xi)),ld_mul(ld_mul(ld_mul(ld_imul(40,xr),xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(20,xr2),xi),Xi)),ld_mul(ld_imul(5,Xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),Xr2),Xr)),ld_mul(ld_imul(10,xi2),Xr2)),ld_mul(ld_imul(30,xr2),Xr2)),ld_mul(ld_mul(ld_imul(20,xr),xi2),Xr)),ld_mul(ld_mul(ld_imul(20,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(10,xr2),xi2)),ld_mul(ld_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,32,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_mul(Xi,fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,33,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,33,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,33,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,33,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(Xi2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2))),d_mul(d_mul(d_imul(4,Xi),Xr),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(Xr2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(Xi2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(Xr2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(4,d_add(d_add(d_mul(Xi,xr),d_mul(xi,Xr)),d_mul(xi,xr))),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),cr);
xin=d_add(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(d_imul(2,Xi2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,Xr),xr),xr2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,xi),Xi),xi2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,33,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(Xi2,ld_diffabs(Xi2,ld_add(ld_mul(ld_imul(2,xi),Xi),xi2))),ld_mul(ld_mul(ld_imul(4,Xi),Xr),ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))))),ld_mul(Xr2,ld_diffabs(Xi2,ld_add(ld_mul(ld_imul(2,xi),Xi),xi2)))),ld_mul(Xi2,ld_diffabs(Xr2,ld_add(ld_mul(ld_imul(2,Xr),xr),xr2)))),ld_mul(Xr2,ld_diffabs(Xr2,ld_add(ld_mul(ld_imul(2,Xr),xr),xr2)))),ld_mul(ld_add(ld_mul(ld_imul(2,xi),Xi),xi2),ld_abs(ld_add(ld_add(Xi2,ld_mul(ld_imul(2,xi),Xi)),xi2)))),ld_mul(ld_imul(4,ld_add(ld_add(ld_mul(Xi,xr),ld_mul(xi,Xr)),ld_mul(xi,xr))),ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr,Xi),ld_mul(Xr,xi)),ld_mul(xr,Xi)),ld_mul(xr,xi))))),ld_mul(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_abs(ld_add(ld_add(Xi2,ld_mul(ld_imul(2,xi),Xi)),xi2)))),ld_mul(ld_add(ld_mul(ld_imul(2,xi),Xi),xi2),ld_abs(ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2)))),ld_mul(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_abs(ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2)))),cr);
xin=ld_add(ld_sub(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr2),ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi)))),ld_mul(ld_mul(ld_imul(2,Xr),Xi),ld_diffabs(Xr2,ld_add(ld_mul(ld_imul(2,Xr),xr),xr2)))),ld_mul(ld_mul(ld_imul(2,Xr),Xi),ld_diffabs(Xi2,ld_add(ld_mul(ld_imul(2,xi),Xi),xi2)))),ld_mul(ld_imul(2,Xi2),ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))))),ld_mul(ld_imul(2,ld_add(ld_mul(ld_imul(2,Xr),xr),xr2)),ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr,Xi),ld_mul(Xr,xi)),ld_mul(xr,Xi)),ld_mul(xr,xi))))),ld_mul(ld_imul(2,ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))),ld_abs(ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2)))),ld_mul(ld_imul(2,ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))),ld_abs(ld_add(ld_add(Xi2,ld_mul(ld_imul(2,xi),Xi)),xi2)))),ld_mul(ld_imul(2,ld_add(ld_mul(ld_imul(2,xi),Xi),xi2)),ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr,Xi),ld_mul(Xr,xi)),ld_mul(xr,Xi)),ld_mul(xr,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,33,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(Xi2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2))),fe_mul(fe_mul(fe_imul(4,Xi),Xr),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(Xr2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(Xi2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(Xr2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(4,fe_add(fe_add(fe_mul(Xi,xr),fe_mul(xi,Xr)),fe_mul(xi,xr))),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),cr);
xin=fe_add(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(fe_imul(2,Xi2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,34,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,34,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,34,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,34,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,34,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(4,xr),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_mul(ld_neg(Xi2),Xi),ld_mul(ld_imul(3,xi),Xi2)),ld_mul(Xr2,Xi)),ld_mul(ld_mul(ld_imul(2,xr),Xr),Xi)),ld_mul(ld_imul(3,xi2),Xi)),ld_mul(xr2,Xi)),ld_mul(xi,Xr2)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xr)),ld_mul(xi2,xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(4,Xr),ld_diffabs(ld_add(ld_mul(ld_neg(Xi2),Xi),ld_mul(Xr2,Xi)),ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_mul(ld_imul(-3,xi),Xi2),ld_mul(ld_mul(ld_imul(2,xr),Xr),Xi)),ld_mul(ld_imul(3,xi2),Xi)),ld_mul(xr2,Xi)),ld_mul(xi,Xr2)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xr)),ld_mul(xi2,xi)),ld_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,34,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,35,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,35,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,35,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,35,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,35,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_sub(ld_mul(ld_imul(-4,Xi),ld_diffabs(ld_sub(ld_mul(Xr2,Xr),ld_mul(Xr,Xi2)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_neg(xr),Xi2),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr)))),ld_mul(ld_imul(4,xi),ld_abs(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_neg(Xr),Xi2),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(Xr2,Xr)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,35,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,36,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,36,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,36,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,36,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,36,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(4,Xr),xr2),xr)),ld_mul(xr2,xr2)),ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_mul(ld_imul(4,Xi),xi2),xi)),ld_mul(xi2,xi2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_mul(ld_imul(12,Xr),xr),Xi2)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),xr),Xi),xi)),ld_mul(ld_mul(ld_imul(12,Xr),xr),xi2)),ld_mul(ld_imul(6,xr2),Xi2)),ld_mul(ld_mul(ld_imul(12,xr2),Xi),xi)),ld_mul(ld_imul(6,xr2),xi2)),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(4,Xi),ld_diffabs(ld_sub(ld_mul(Xr2,Xr),ld_mul(Xr,Xi2)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_neg(xr),Xi2),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr)))),ld_mul(ld_imul(4,xi),ld_abs(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_neg(Xr),Xi2),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(Xr2,Xr)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,36,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,37,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,37,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,37,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,37,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,37,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi),ld_mul(ld_mul(ld_imul(12,Xi2),xr),Xr)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_imul(6,Xi2),xr2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),Xi),xr),xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(12,xi),Xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(12,xi2),Xr),xr)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(6,xi2),xr2)),ld_mul(xr2,xr2))),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(4,xr),ld_abs(ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_mul(ld_neg(Xi2),Xi),ld_mul(ld_imul(3,xi),Xi2)),ld_mul(Xr2,Xi)),ld_mul(ld_mul(ld_imul(2,xr),Xr),Xi)),ld_mul(ld_imul(3,xi2),Xi)),ld_mul(xr2,Xi)),ld_mul(xi,Xr2)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xr)),ld_mul(xi2,xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(4,Xr),ld_diffabs(ld_add(ld_mul(ld_neg(Xi2),Xi),ld_mul(Xr2,Xi)),ld_add(ld_sub(ld_add(ld_add(ld_add(ld_sub(ld_add(ld_mul(ld_imul(-3,xi),Xi2),ld_mul(ld_mul(ld_imul(2,xr),Xr),Xi)),ld_mul(ld_imul(3,xi2),Xi)),ld_mul(xr2,Xi)),ld_mul(xi,Xr2)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xr)),ld_mul(xi2,xi)),ld_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,37,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,38,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,38,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,38,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,38,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,38,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi),ld_mul(ld_mul(ld_imul(12,Xi2),xr),Xr)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_imul(6,Xi2),xr2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),Xi),xr),xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(12,xi),Xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(12,xi2),Xr),xr)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(6,xi2),xr2)),ld_mul(xr2,xr2))),cr);
xin=ld_add(ld_sub(ld_mul(ld_imul(-4,Xi),ld_diffabs(ld_sub(ld_mul(Xr2,Xr),ld_mul(Xr,Xi2)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_neg(xr),Xi2),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr)))),ld_mul(ld_imul(4,xi),ld_abs(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_neg(Xr),Xi2),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(Xr2,Xr)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,38,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,39,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,39,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,39,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,39,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,39,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_diffabs(ld_sub(ld_add(ld_mul(Xr2,Xr2),ld_mul(Xi2,Xi2)),ld_mul(ld_imul(6,Xr2),Xi2)),ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_sub(ld_mul(ld_mul(ld_imul(4,Xi2),Xi),xi),ld_mul(ld_mul(ld_imul(12,Xi2),xr),Xr)),ld_mul(ld_imul(6,Xi2),xi2)),ld_mul(ld_imul(6,Xi2),xr2)),ld_mul(ld_mul(ld_imul(12,Xr2),Xi),xi)),ld_mul(ld_mul(ld_mul(ld_imul(24,Xr),Xi),xr),xi)),ld_mul(ld_mul(ld_imul(4,xi2),xi),Xi)),ld_mul(ld_mul(ld_imul(12,xi),Xi),xr2)),ld_mul(ld_mul(ld_imul(4,Xr2),Xr),xr)),ld_mul(ld_imul(6,Xr2),xi2)),ld_mul(ld_imul(6,Xr2),xr2)),ld_mul(ld_mul(ld_imul(12,xi2),Xr),xr)),ld_mul(ld_mul(ld_imul(4,xr2),xr),Xr)),ld_mul(xi2,xi2)),ld_mul(ld_imul(6,xi2),xr2)),ld_mul(xr2,xr2))),cr);
xin=ld_add(ld_add(ld_mul(ld_imul(4,Xi),ld_diffabs(ld_sub(ld_mul(Xr2,Xr),ld_mul(Xr,Xi2)),ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_sub(ld_mul(ld_neg(xr),Xi2),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr)))),ld_mul(ld_imul(4,xi),ld_abs(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_neg(Xr),Xi2),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xi),Xr),Xi)),ld_mul(ld_mul(ld_imul(2,xr),xi),Xi)),ld_mul(Xr2,Xr)),ld_mul(ld_imul(3,xr),Xr2)),ld_mul(xi2,Xr)),ld_mul(ld_imul(3,xr2),Xr)),ld_mul(xr,xi2)),ld_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,39,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,40,6)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,40,6)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,40,6)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,40,6)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xr))),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr,Xi2))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr,Xi2))),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,40,6)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_add(ld_sub(ld_add(ld_sub(ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr2,Xi),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(Xi2,Xi)),ld_mul(ld_diffabs(ld_mul(Xi2,Xi),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi))),ld_mul(Xi2,Xi))),ld_mul(ld_imul(9,ld_diffabs(ld_mul(Xr,Xi2),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(Xr,Xi2))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr2,Xr),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_mul(Xr,Xi2))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xi2,Xi),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(Xr2,Xi))),ld_mul(ld_imul(9,ld_diffabs(ld_mul(Xr2,Xi),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(Xr2,Xi))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr,Xi2),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(Xr2,Xr))),ld_mul(ld_diffabs(ld_mul(Xr2,Xr),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr))),ld_mul(Xr2,Xr))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,Xi),ld_mul(Xr2,xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(ld_abs(ld_add(ld_add(ld_add(ld_mul(Xi2,Xi),ld_mul(ld_imul(3,Xi2),xi)),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi))),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(ld_imul(9,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr,Xi2),ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi)),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr2,Xr),ld_mul(ld_imul(3,Xr2),xr)),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_mul(Xi2,Xi),ld_mul(ld_imul(3,Xi2),xi)),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(9,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,Xi),ld_mul(Xr2,xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr,Xi2),ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi)),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_mul(ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr2,Xr),ld_mul(ld_imul(3,Xr2),xr)),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr))),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),cr);
xin=ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_add(ld_add(ld_sub(ld_add(ld_add(ld_sub(ld_sub(ld_sub(ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr,Xi2),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(Xi2,Xi)),ld_mul(ld_diffabs(ld_mul(Xr2,Xr),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr))),ld_mul(Xi2,Xi))),ld_mul(ld_imul(9,ld_diffabs(ld_mul(Xr2,Xi),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(Xr,Xi2))),ld_mul(ld_imul(9,ld_diffabs(ld_mul(Xr,Xi2),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(Xr2,Xi))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr2,Xr),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_mul(Xr2,Xi))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xi2,Xi),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(Xr,Xi2))),ld_mul(ld_diffabs(ld_mul(Xi2,Xi),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi))),ld_mul(Xr2,Xr))),ld_mul(ld_imul(3,ld_diffabs(ld_mul(Xr2,Xi),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(Xr2,Xr))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr,Xi2),ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi)),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr2,Xr),ld_mul(ld_imul(3,Xr2),xr)),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr))),ld_add(ld_add(ld_mul(ld_imul(3,Xi2),xi),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_mul(ld_imul(9,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,Xi),ld_mul(Xr2,xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(ld_imul(9,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr,Xi2),ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi)),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_mul(Xr2,Xr),ld_mul(ld_imul(3,Xr2),xr)),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,xi),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_mul(Xi2,Xi),ld_mul(ld_imul(3,Xi2),xi)),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi)))),ld_add(ld_add(ld_add(ld_add(ld_mul(ld_mul(ld_imul(2,Xr),Xi),xi),ld_mul(Xr,xi2)),ld_mul(xr,Xi2)),ld_mul(ld_mul(ld_imul(2,xr),Xi),xi)),ld_mul(xr,xi2)))),ld_mul(ld_abs(ld_add(ld_add(ld_add(ld_mul(Xi2,Xi),ld_mul(ld_imul(3,Xi2),xi)),ld_mul(ld_imul(3,Xi),xi2)),ld_mul(xi2,xi))),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ld_mul(ld_imul(3,ld_abs(ld_add(ld_add(ld_add(ld_add(ld_add(ld_mul(Xr2,Xi),ld_mul(Xr2,xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),Xi)),ld_mul(ld_mul(ld_imul(2,Xr),xr),xi)),ld_mul(xr2,Xi)),ld_mul(xr2,xi)))),ld_add(ld_add(ld_mul(ld_imul(3,Xr2),xr),ld_mul(ld_imul(3,Xr),xr2)),ld_mul(xr2,xr)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,40,6)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xr))),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,41,2)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,41,2)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,41,2)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,41,2)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{xrn=d_add(d_sub(d_sub(d_mul(xr,d_add(d_imul(2,Xr),xr)),d_mul(xi,d_add(xi,d_imul(2,Xi)))),d_diffabs(Xr,xr)),cr);
xin=d_add(d_sub(d_muli(d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),2),d_diffabs(Xi,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,41,2)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{xrn=ld_add(ld_sub(ld_sub(ld_mul(xr,ld_add(ld_imul(2,Xr),xr)),ld_mul(xi,ld_add(xi,ld_imul(2,Xi)))),ld_diffabs(Xr,xr)),cr);
xin=ld_add(ld_sub(ld_muli(ld_diffabs(ld_mul(Xr,Xi),ld_add(ld_add(ld_mul(Xr,xi),ld_mul(xr,Xi)),ld_mul(xr,xi))),2),ld_diffabs(Xi,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,41,2)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{xrn=fe_add(fe_sub(fe_sub(fe_mul(xr,fe_add(fe_imul(2,Xr),xr)),fe_mul(xi,fe_add(xi,fe_imul(2,Xi)))),fe_diffabs(Xr,xr)),cr);
xin=fe_add(fe_sub(fe_muli(fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),2),fe_diffabs(Xi,xi)),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,42,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,42,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,42,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,42,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex X2 = dc_mul(X, X);
const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,42,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex X2 = ldc_mul(X, X);
const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(3,X2),x)),ldc_mul(ldc_imul(3,X),x2)),ldc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,42,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex X2 = fec_mul(X, X);
const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,43,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,43,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,43,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,43,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex X2 = dc_mul(X, X);
const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,43,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex X2 = ldc_mul(X, X);
const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_sub(ldc_sub(ldc_sub(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(3,X2),x)),ldc_mul(ldc_imul(3,X),x2)),ldc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,43,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex X2 = fec_mul(X, X);
const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,44,3)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,44,3)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,44,3)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,44,3)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex X2 = dc_mul(X, X);
const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_imul(2,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,44,3)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex X2 = ldc_mul(X, X);
const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_sub(ldc_sub(ldc_sub(ldc_imul(2,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(3,X2),x)),ldc_mul(ldc_imul(3,X),x2)),ldc_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,44,3)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex X2 = fec_mul(X, X);
const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_imul(2,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,45,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,45,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,45,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,45,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_pow(X,3)),x)),dc_mul(dc_imul(6,dc_pow(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,45,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(4,ldc_pow(X,3)),x)),ldc_mul(ldc_imul(6,ldc_pow(X,2)),x2)),ldc_mul(ldc_mul(ldc_imul(4,X),x2),x)),ldc_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,45,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_pow(X,3)),x)),fec_mul(fec_imul(6,fec_pow(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,46,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,46,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,46,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,46,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_pow(X,3)),x)),dc_mul(dc_imul(6,dc_pow(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,46,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(4,ldc_pow(X,3)),x)),ldc_mul(ldc_imul(6,ldc_pow(X,2)),x2)),ldc_mul(ldc_mul(ldc_imul(4,X),x2),x)),ldc_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,46,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_pow(X,3)),x)),fec_mul(fec_imul(6,fec_pow(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_pow(x2,2)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,47,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,47,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,47,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,47,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_pow(X,4)),x)),dc_mul(dc_imul(10,dc_pow(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_pow(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_pow(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,47,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(5,ldc_pow(X,4)),x)),ldc_mul(ldc_imul(10,ldc_pow(X,3)),x2)),ldc_mul(ldc_mul(ldc_imul(10,ldc_pow(X,2)),x2),x)),ldc_mul(ldc_imul(5,X),ldc_pow(x2,2))),ldc_mul(ldc_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,47,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_pow(X,4)),x)),fec_mul(fec_imul(10,fec_pow(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_pow(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_pow(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,48,5)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,48,5)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,48,5)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,48,5)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_pow(X,4)),x)),dc_mul(dc_imul(10,dc_pow(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_pow(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_pow(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,48,5)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(5,ldc_pow(X,4)),x)),ldc_mul(ldc_imul(10,ldc_pow(X,3)),x2)),ldc_mul(ldc_mul(ldc_imul(10,ldc_pow(X,2)),x2),x)),ldc_mul(ldc_imul(5,X),ldc_pow(x2,2))),ldc_mul(ldc_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,48,5)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_pow(X,4)),x)),fec_mul(fec_imul(10,fec_pow(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_pow(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_pow(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,49,6)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,49,6)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,49,6)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,49,6)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{const dcomplex x2 = dc_mul(x, x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(6,dc_pow(X,5)),x)),dc_mul(dc_imul(15,dc_pow(X,4)),x2)),dc_mul(dc_imul(20,dc_pow(X,3)),dc_mul(x2,x))),dc_mul(dc_imul(15,dc_pow(X,2)),dc_pow(x2,2))),dc_mul(dc_imul(6,X),dc_mul(dc_mul(x2,x2),x))),dc_pow(x2,3)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,49,6)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{const ldcomplex x2 = ldc_mul(x, x);
xn=ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_add(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),x2)),ldc_mul(ldc_imul(6,ldc_pow(X,5)),x)),ldc_mul(ldc_imul(15,ldc_pow(X,4)),x2)),ldc_mul(ldc_imul(20,ldc_pow(X,3)),ldc_mul(x2,x))),ldc_mul(ldc_imul(15,ldc_pow(X,2)),ldc_pow(x2,2))),ldc_mul(ldc_imul(6,X),ldc_mul(ldc_mul(x2,x2),x))),ldc_pow(x2,3)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,49,6)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{const fecomplex x2 = fec_mul(x, x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(6,fec_pow(X,5)),x)),fec_mul(fec_imul(15,fec_pow(X,4)),x2)),fec_mul(fec_imul(20,fec_pow(X,3)),fec_mul(x2,x))),fec_mul(fec_imul(15,fec_pow(X,2)),fec_pow(x2,2))),fec_mul(fec_imul(6,X),fec_mul(fec_mul(x2,x2),x))),fec_pow(x2,3)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,50,6)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,50,6)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,50,6)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,50,6)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


      const dcomplex X = {Xr, Xi}, x = {xr, xi};
      dcomplex xn;
{xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),dc_pow(x,2))),dc_mul(dc_imul(6,dc_pow(X,5)),x)),dc_mul(dc_imul(15,dc_pow(X,4)),dc_pow(x,2))),dc_mul(dc_imul(20,dc_pow(X,3)),dc_pow(x,3))),dc_mul(dc_imul(15,dc_pow(X,2)),dc_pow(x,4))),dc_mul(dc_imul(6,X),dc_pow(x,5))),dc_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,50,6)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


      const ldcomplex X = {Xr, Xi}, x = {xr, xi};
      ldcomplex xn;
{xn=ldc_add(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_sub(ldc_mul(A,ldc_add(ldc_mul(ldc_imul(2,X),x),ldc_pow(x,2))),ldc_mul(ldc_imul(6,ldc_pow(X,5)),x)),ldc_mul(ldc_imul(15,ldc_pow(X,4)),ldc_pow(x,2))),ldc_mul(ldc_imul(20,ldc_pow(X,3)),ldc_pow(x,3))),ldc_mul(ldc_imul(15,ldc_pow(X,2)),ldc_pow(x,4))),ldc_mul(ldc_imul(6,X),ldc_pow(x,5))),ldc_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,50,6)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


      const fecomplex X = {Xr, Xi}, x = {xr, xi};
      fecomplex xn;
{xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),fec_pow(x,2))),fec_mul(fec_imul(6,fec_pow(X,5)),x)),fec_mul(fec_imul(15,fec_pow(X,4)),fec_pow(x,2))),fec_mul(fec_imul(20,fec_pow(X,3)),fec_pow(x,3))),fec_mul(fec_imul(15,fec_pow(X,2)),fec_pow(x,4))),fec_mul(fec_imul(6,X),fec_pow(x,5))),fec_pow(x,6)),c);
}
      xrn = xn.re; xin = xn.im;


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool FORMULA(reference_double,51,4)(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const double Xrd = mpfr_get_d(Xr, MPFR_RNDN); \
      const double Xid = mpfr_get_d(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = g_real * Xrd * Xrd + g_imag * Xid * Xid; \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_long_double,51,4)(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = g_real == 1 && g_imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const long double Xrl = mpfr_get_ld(Xr, MPFR_RNDN); \
      const long double Xil = mpfr_get_ld(Xi, MPFR_RNDN); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = Xrl * Xrl + Xil * Xil; \
      else \
        abs_val = g_real * Xrl * Xrl + g_imag * Xil * Xil; \
      const double Xz = abs_val * glitch; \
      m_ldxr[i] = Xrl; \
      m_ldxi[i] = Xil; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}

bool FORMULA(reference_floatexp,51,4)(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr0, const CFixedFloat &Ci0, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const floatexp real, const floatexp imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    const bool no_g = real == 1 && imag == 1;
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      const floatexp Xrf = mpfr_get_fe(Xr); \
      const floatexp Xif = mpfr_get_fe(Xi); \
      old_absval = abs_val; \
      if (no_g) \
        abs_val = (Xrf * Xrf + Xif * Xif).todouble(); \
      else \
        abs_val = (real * Xrf * Xrf + imag * Xif * Xif).todouble(); \
      const double Xz = abs_val * glitch; \
      m_dxr[i] = Xrf; \
      m_dxi[i] = Xif; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) {
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);



#undef LOOP

    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    return true;
  }
  return false;
}


bool FORMULA(perturbation_double,51,4)(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, const double xr0, const double xi0, const double cr, const double ci)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const dcomplex A = { g_FactorAR, g_FactorAI };
    const dcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    double xr = xr0;
    double xi = xi0;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const double Xr = m_db_dxr[antal];
      const double Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      const double Xxr = Xr + xr;
      const double Xxi = Xi + xi;
      test2 = test1;
      test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      double xrn, xin;


{const double Xr2 = Xr * Xr;
const double Xi2 = Xi * Xi;
const double xr2 = xr * xr;
const double xi2 = xi * xi;
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_sub(d_sub(d_sub(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_sub(d_sub(d_add(d_add(d_sub(Xr2,Xi2),d_mul(d_imul(2,Xr),xr)),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_long_double,51,4)(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal0, double &test10, double &test20, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const ldcomplex A = { g_FactorAR, g_FactorAI };
    const ldcomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    const bool no_g = g_real == 1 && g_imag == 1;
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const long double Xr = dxr[antal];
      const long double Xi = dxi[antal];
      const double Xz = m_db_z[antal];
      const long double Xxr = Xr + xr;
      const long double Xxi = Xi + xi;
      test2 = test1;
      if (no_g)
      {
        test1 = Xxr * Xxr + Xxi * Xxi;
      }
      else
      {
        test1 = g_real * Xxr * Xxr + g_imag * Xxi * Xxi;
      }
      if (test1 < Xz)
      {
        if (! m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      long double xrn, xin;


{const long double Xr2 = Xr * Xr;
const long double Xi2 = Xi * Xi;
const long double xr2 = xr * xr;
const long double xi2 = xi * xi;
xrn=ld_add(ld_sub(ld_sub(ld_add(ld_mul(ld_sub(Xr2,Xi2),ld_diffabs(ld_sub(Xr2,Xi2),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2))),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2),ld_abs(ld_sub(ld_sub(ld_sub(ld_add(ld_add(Xr2,ld_mul(ld_imul(2,Xr),xr)),xr2),Xi2),ld_mul(ld_imul(2,Xi),xi)),xi2)))),ld_mul(ld_mul(ld_imul(2,Xr),Xi),ld_diffabs(ld_mul(ld_imul(2,Xr),Xi),ld_add(ld_add(ld_mul(ld_imul(2,Xr),xi),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi))))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(2,Xr),xi),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi)),ld_abs(ld_add(ld_add(ld_add(ld_mul(ld_imul(2,Xr),Xi),ld_mul(ld_imul(2,Xr),xi)),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi))))),cr);
xin=ld_add(ld_add(ld_add(ld_add(ld_mul(ld_sub(Xr2,Xi2),ld_diffabs(ld_mul(ld_imul(2,Xr),Xi),ld_add(ld_add(ld_mul(ld_imul(2,Xr),xi),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi)))),ld_mul(ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2),ld_abs(ld_add(ld_add(ld_add(ld_mul(ld_imul(2,Xr),Xi),ld_mul(ld_imul(2,Xr),xi)),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi))))),ld_mul(ld_mul(ld_imul(2,Xr),Xi),ld_diffabs(ld_sub(Xr2,Xi2),ld_sub(ld_sub(ld_add(ld_mul(ld_imul(2,Xr),xr),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2)))),ld_mul(ld_add(ld_add(ld_mul(ld_imul(2,Xr),xi),ld_mul(ld_imul(2,xr),Xi)),ld_mul(ld_imul(2,xr),xi)),ld_abs(ld_sub(ld_sub(ld_add(ld_add(ld_sub(Xr2,Xi2),ld_mul(ld_imul(2,Xr),xr)),xr2),ld_mul(ld_imul(2,Xi),xi)),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    return true;
  }
  return false;
}

bool FORMULA(perturbation_floatexp,51,4)(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const fecomplex A = { g_FactorAR, g_FactorAI };
    const fecomplex c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    for (; antal < nMaxIter && test1 <= m_nBailout2; antal++)
    {
      const floatexp Xr = m_dxr[antal];
      const floatexp Xi = m_dxi[antal];
      const floatexp Xxr = Xr + xr;
      const floatexp Xxi = Xi + xi;
      test2 = test1;
      test1 = (real*Xxr*Xxr + imag*Xxi*Xxi).todouble();
      if (test1 < m_db_z[antal]){
        if (!m_bNoGlitchDetection)
          test1 = m_nBailout2 * 2;
        bGlitch = true;
      }
      floatexp xrn, xin;


{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_sub(fe_sub(fe_add(fe_add(fe_sub(Xr2,Xi2),fe_mul(fe_imul(2,Xr),xr)),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),ci);
}


      xr = xrn;
      xi = xin;
    }
    return true;
  }
  return false;
}





bool reference_double(int m_nFractalType, int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, double g_SeedR, double g_SeedI, double g_FactorAR, double g_FactorAI, double terminate, double g_real, double g_imag, bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,0,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_double,0,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_double,0,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_double,0,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference_double,0,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference_double,0,7)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference_double,0,8)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference_double,0,9)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference_double,0,10)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,1,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_double,1,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_double,1,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_double,1,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,2,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_double,2,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_double,2,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_double,2,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,3,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_double,3,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_double,3,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_double,3,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,4,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_double,4,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_double,4,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_double,4,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,5,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,6,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,7,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,8,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,9,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,10,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,11,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,12,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,13,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,14,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,15,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,16,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,17,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,18,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,19,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,20,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,21,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,22,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,23,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,24,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,25,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,26,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,27,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,28,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,29,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,30,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,31,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,32,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,33,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,34,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,35,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,36,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,37,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,38,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,39,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_double,40,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_double,41,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,42,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,43,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_double,44,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,45,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,46,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,47,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_double,48,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_double,49,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_double,50,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_double,51,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}


bool reference_long_double(int m_nFractalType, int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, double g_SeedR, double g_SeedI, double g_FactorAR, double g_FactorAI, double terminate, double g_real, double g_imag, bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,0,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_long_double,0,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_long_double,0,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_long_double,0,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference_long_double,0,6)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference_long_double,0,7)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference_long_double,0,8)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference_long_double,0,9)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference_long_double,0,10)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,1,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_long_double,1,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_long_double,1,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_long_double,1,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,2,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_long_double,2,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_long_double,2,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_long_double,2,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,3,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_long_double,3,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_long_double,3,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_long_double,3,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,4,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_long_double,4,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_long_double,4,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_long_double,4,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,5,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,6,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,7,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,8,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,9,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,10,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,11,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,12,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,13,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,14,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,15,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,16,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,17,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,18,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,19,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,20,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,21,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,22,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,23,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,24,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,25,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,26,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,27,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,28,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,29,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,30,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,31,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,32,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,33,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,34,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,35,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,36,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,37,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,38,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,39,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_long_double,40,6)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_long_double,41,2)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,42,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,43,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_long_double,44,3)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,45,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,46,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,47,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_long_double,48,5)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_long_double,49,6)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_long_double,50,6)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_long_double,51,4)(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}


bool reference_floatexp(int m_nFractalType, int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, double g_SeedR, double g_SeedI, double g_FactorAR, double g_FactorAI, double terminate, floatexp real, floatexp imag, bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,0,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_floatexp,0,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_floatexp,0,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_floatexp,0,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference_floatexp,0,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference_floatexp,0,7)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference_floatexp,0,8)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference_floatexp,0,9)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference_floatexp,0,10)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,1,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_floatexp,1,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_floatexp,1,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_floatexp,1,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,2,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_floatexp,2,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_floatexp,2,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_floatexp,2,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,3,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_floatexp,3,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_floatexp,3,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_floatexp,3,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,4,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference_floatexp,4,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference_floatexp,4,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference_floatexp,4,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,5,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,6,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,7,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,8,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,9,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,10,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,11,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,12,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,13,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,14,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,15,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,16,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,17,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,18,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,19,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,20,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,21,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,22,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,23,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,24,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,25,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,26,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,27,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,28,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,29,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,30,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,31,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,32,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,33,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,34,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,35,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,36,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,37,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,38,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,39,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_floatexp,40,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference_floatexp,41,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,42,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,43,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference_floatexp,44,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,45,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,46,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,47,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference_floatexp,48,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_floatexp,49,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference_floatexp,50,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference_floatexp,51,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, real, imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}



bool perturbation_double(int m_nFractalType, int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, double xr, double xi, const double cr, const double ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,0,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_double,0,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_double,0,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_double,0,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation_double,0,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation_double,0,7)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation_double,0,8)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation_double,0,9)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation_double,0,10)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,1,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_double,1,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_double,1,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_double,1,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,2,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_double,2,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_double,2,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_double,2,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,3,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_double,3,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_double,3,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_double,3,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,4,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_double,4,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_double,4,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_double,4,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,5,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,6,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,7,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,8,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,9,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,10,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,11,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,12,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,13,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,14,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,15,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,16,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,17,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,18,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,19,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,20,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,21,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,22,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,23,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,24,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,25,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,26,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,27,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,28,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,29,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,30,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,31,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,32,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,33,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,34,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,35,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,36,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,37,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,38,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,39,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_double,40,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_double,41,2)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,42,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,43,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_double,44,3)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,45,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,46,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,47,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_double,48,5)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_double,49,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_double,50,6)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_double,51,4)(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}



bool perturbation_long_double(int m_nFractalType, int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, double g_real, double g_imag, double g_FactorAR, double g_FactorAI, long double xr, long double xi, const long double cr, const long double ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,0,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_long_double,0,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_long_double,0,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_long_double,0,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation_long_double,0,6)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation_long_double,0,7)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation_long_double,0,8)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation_long_double,0,9)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation_long_double,0,10)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,1,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_long_double,1,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_long_double,1,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_long_double,1,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,2,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_long_double,2,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_long_double,2,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_long_double,2,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,3,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_long_double,3,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_long_double,3,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_long_double,3,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,4,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_long_double,4,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_long_double,4,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_long_double,4,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,5,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,6,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,7,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,8,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,9,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,10,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,11,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,12,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,13,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,14,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,15,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,16,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,17,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,18,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,19,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,20,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,21,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,22,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,23,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,24,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,25,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,26,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,27,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,28,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,29,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,30,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,31,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,32,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,33,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,34,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,35,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,36,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,37,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,38,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,39,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_long_double,40,6)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_long_double,41,2)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,42,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,43,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_long_double,44,3)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,45,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,46,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,47,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_long_double,48,5)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_long_double,49,6)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_long_double,50,6)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_long_double,51,4)(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}



bool perturbation_floatexp(int m_nFractalType, int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, double m_nBailout2, int nMaxIter, int m_bNoGlitchDetection, floatexp real, floatexp imag, double g_FactorAR, double g_FactorAI, floatexp xr, floatexp xi, const floatexp cr, const floatexp ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,0,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_floatexp,0,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_floatexp,0,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_floatexp,0,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation_floatexp,0,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation_floatexp,0,7)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation_floatexp,0,8)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation_floatexp,0,9)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation_floatexp,0,10)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,1,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_floatexp,1,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_floatexp,1,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_floatexp,1,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,2,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_floatexp,2,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_floatexp,2,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_floatexp,2,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,3,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_floatexp,3,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_floatexp,3,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_floatexp,3,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,4,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation_floatexp,4,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation_floatexp,4,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation_floatexp,4,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,5,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,6,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,7,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,8,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,9,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,10,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,11,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,12,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,13,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,14,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,15,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,16,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,17,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,18,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,19,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,20,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,21,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,22,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,23,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,24,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,25,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,26,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,27,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,28,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,29,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,30,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,31,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,32,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,33,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,34,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,35,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,36,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,37,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,38,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,39,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_floatexp,40,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation_floatexp,41,2)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,42,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,43,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation_floatexp,44,3)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,45,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,46,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,47,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation_floatexp,48,5)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_floatexp,49,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation_floatexp,50,6)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation_floatexp,51,4)(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, real, imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}


void combo5_addstrings(HWND hWnd, int IDC_COMBO5)
{
  
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbrot"); // 0
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Burning Ship"); // 1
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Buffalo"); // 2
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Celtic"); // 3
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar"); // 4
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar Celtic"); // 5
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Mandelbrot"); // 6
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Burning Ship"); // 7
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Celtic"); // 8
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Buffalo"); // 9
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Burning Ship"); // 10
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Real"); // 11
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Imag"); // 12
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Flying Squirrel (Buffalo Imag)"); // 13
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Perpendicular"); // 14
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Imag"); // 15
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real"); // 16
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real Mbar"); // 17
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Imag"); // 18
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real"); // 19
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real Mbar"); // 20
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Buffalo Partial Imag"); // 21
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Mbar"); // 22
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Perpendicular"); // 23
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Heart"); // 24
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi Perpendicular"); // 25
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi HEart"); // 26
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial"); // 27
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial Mbar"); // 28
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Celtic Mbar"); // 29
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Burning Ship (BS/Buffalo Hybrid)"); // 30
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Perpendicular"); // 31
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Heart"); // 32
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 4th"); // 33
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Imag Quasi Perpendicular / Heart"); // 34
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Perpendicular"); // 35
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Heart"); // 36
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Imag Quasi Perpendicular / Heart"); // 37
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Perpendicular"); // 38
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Heart"); // 39
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 6th"); // 40
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"HPDZ Buffalo"); // 41
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 1: a*z^2+z^3+c"); // 42
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 2: a*z^2-z^3+c"); // 43
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 3: 2*z^2-z^3+c"); // 44
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 4: a*z^2+z^4+c"); // 45
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 5: a*z^2-z^4+c"); // 46
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 6: a*z^2+z^5+c"); // 47
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 7: a*z^2-z^5+c"); // 48
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 8: a*z^2+z^6+c"); // 49
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 9: a*z^2-z^6+c"); // 50
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot2 4th"); // 51
}


int validate_power_for_fractal_type(int m_nFractalType, int m_nPower)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
        case 6: return 6;
      
        case 7: return 7;
      
        case 8: return 8;
      
        case 9: return 9;
      
        case 10: return 10;
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi HEart
    case 26:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    default:
      return 2;
  }
}


void update_power_dropdown_for_fractal_type(HWND hWnd, int IDC_COMBO3, int m_nFractalType, int m_nPower)
{
  SendDlgItemMessage(hWnd,IDC_COMBO3,CB_RESETCONTENT,0,0);
  int selected = 0;
  int ix = 0;
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
        if (7 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"7");
        ix++;
      
        if (8 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"8");
        ix++;
      
        if (9 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"9");
        ix++;
      
        if (10 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"10");
        ix++;
      
      break;
    }
  
    // Burning Ship
    case 1:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Buffalo
    case 2:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Celtic
    case 3:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar
    case 4:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar Celtic
    case 5:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Mandelbrot
    case 6:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Burning Ship
    case 7:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Celtic
    case 8:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Buffalo
    case 9:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Burning Ship
    case 10:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Real
    case 11:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Imag
    case 12:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Perpendicular
    case 14:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Imag
    case 15:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real
    case 16:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Buffalo Partial Imag
    case 21:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Mbar
    case 22:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Perpendicular
    case 23:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Heart
    case 24:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi HEart
    case 26:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial
    case 27:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial Mbar
    case 28:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Celtic Mbar
    case 29:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Perpendicular
    case 31:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Heart
    case 32:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // SimonBrot 4th
    case 33:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Perpendicular
    case 35:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Heart
    case 36:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Heart
    case 39:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // SimonBrot 6th
    case 40:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // HPDZ Buffalo
    case 41:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // SimonBrot2 4th
    case 51:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
  }
	SendDlgItemMessage(hWnd,IDC_COMBO3,CB_SETCURSEL,selected,0);
	EnableWindow(GetDlgItem(hWnd,IDC_COMBO3), ix > 1);
}


// EOF
